﻿using System;
using System.Collections.Generic;
using System.Web;

/// <summary>
/// Summary description for UrlConfig
/// </summary>
public class UrlConfig
{
	public UrlConfig()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    public static string Source_Video_Path()
    {
        return Upload_Path("default");
    }
    public static string Source_Video_Path(string username)
    {
        return Upload_Path(username,"default");
    }
    public static string Published_Video_Path()
    {
        return Upload_Path("flv");
    }
    public static string Published_Video_Path(string username)
    {
        return Upload_Path(username, "flv");
    }
    public static string MP3_Path()
    {
        return Upload_Path("mp3");
    }
    public static string MP3_Path(string username)
    {
        return Upload_Path(username, "mp3");
    }
    public static string Thumbs_Path()
    {
        return Upload_Path("thumbs");
    }
    public static string Thumbs_Path(string username)
    {
        return Upload_Path(username, "thumbs");
    }
    public static string Upload_Path(string username, string foldername)
    {
        return HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath) + "/contents/member/" + username + "/" + foldername;
        //return HttpContext.Current.Server.MapPath("~/contents/member/" + username + "" + foldername);
    }

    public static string Upload_Path(string foldername)
    {
        //
        // return HttpContext.Current.Server.MapPath("~/contents/" + foldername);
        return HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath) + "/contents/" + foldername;
    }
    // Generate Tag Url
    public static string Prepare_Tag_Url(string tag, int type, bool maintag)
    {      
        string path = Generate_Tag_Path(type,maintag);
        string query = UtilityBLL.ReplaceSpaceWithHyphin_v2(tag.Trim().ToLower());
        if (type == 5)
        {
            // user searches
            return Config.GetUrl("search.aspx?query=" + query);
        }
        else
        {
            // normal tags
            return  Config.GetUrl() + "" + path + "" + query + ".aspx";
        }
       
    }

    private static string Generate_Tag_Path(int type, bool maintag)
    {
        string Path = "";
        if (Site_Settings.isMainTagProfile && maintag) // single tag path for every type of contents e.g videos, photos, blogs etc
            Path = "tag/";
        else
        {
            switch (type)
            {
                case 0:
                    // videos
                    Path = "videos/tag/";
                    break;
                case 1:
                    // groups
                    Path = "groups/tag/";
                    break;
                case 2:
                    // photos
                    Path = "photos/tag/";
                    break;
                case 3:
                    // blogs
                    Path = "blogs/tag/";
                    break;
                case 4:
                    // audio files
                    Path = "audio/tag/";
                    break;
                case 6:
                    // galleries
                    Path = "galleries/tag/";
                    break;
                case 7:
                    // forums
                    Path = "forums/tag/";
                    break;
                case 11:
                    // qa
                    Path = "qa/tag/";
                    break;
                case 8:
                    // video album
                    Path = "albums/videos/tag/";
                    break;
                case 9:
                    // audio album
                    Path = "albums/audio/tag/";
                    break;
            }
        }

        return Path;
    }
  
    // Generate Category Url
    public static string Prepare_Category_Url(int categoryid, string categoryname, string term, int type, bool maincategory)
    {
        string URL = "";
        string PATH = "";
        if (Site_Settings.isMainCategoryProfile && maincategory) // single main category point for all type of contents e.g photos, videos, audio files, blogs
            PATH = "category/";
        else
        {
            switch (type)
            {
                case 0:
                    PATH = "videos/category/";
                    break;
                case 1:
                    PATH = "groups/category/";
                    break;
                case 2:
                    PATH = "channel/type/";
                    break;
                case 5:
                    PATH = "photos/category/";
                    break;
                case 6:
                    PATH = "blogs/category/";
                    break;
                case 7:
                    PATH = "audio/category/";
                    break;
                case 8:
                    PATH = "galleries/category/";
                    break;
                case 11:
                    PATH = "qa/category/";
                    break;
                case 12:
                    PATH = "forums/category/";
                    break;
            }
        }

        string _term = categoryname;
        if (term != "")
            _term = term;

        URL = Config.GetUrl() + "" + PATH + "" + UtilityBLL.ReplaceSpaceWithHyphin_v2(_term.Trim().ToLower()) + ".aspx";

        return URL;
    }

    public static string Prepare_Archive_Url(int year, int month, string monthname, int type, bool mainprofile)
    {
        string URL = "";
        string PATH = "";
        if (Site_Settings.isMainArchiveProfile && mainprofile) // main archive profile for all content types
            PATH = "archive/";
        else
        {
            switch (type)
            {
                case 0:
                    PATH = "videos/archive/";
                    break;
                case 1:
                    PATH = "groups/archive/";
                    break;
                case 5:
                    PATH = "photos/archive/";
                    break;
                case 6:
                    PATH = "blogs/archive/";
                    break;
                case 7:
                    PATH = "audio/archive/";
                    break;
                case 8:
                    PATH = "galleries/archive/";
                    break;
                case 9:
                    PATH = "forums/archive/";
                    break;
            }
        }

        URL = Config.GetUrl() + "" + PATH + "" + "" + year + "/" + month + "/default.aspx";

        return URL;
    }
    // Generate Public User Profile Url
    public static string Prepare_User_Profile_Url(string username, bool isadmin)
    {
        string _url="";
        if(isadmin)
            _url = Config.GetUrl() + "adm/sc/members/MemberDetail.aspx?user=" + username + "";
        else
            _url = Config.GetUrl() + "user/" + username.ToLower() + ".aspx";

        return _url;
    }

    public static string Prepare_User_Profile_Url(string username, string section, bool isadmin)
    {
        string _url = "";
        if (isadmin)
            _url = Config.GetUrl() + "adm/sc/members/MemberDetail.aspx?user=" + username + "";
        else
        {
            if (section != "")
                section = section + "/";
            _url = Config.GetUrl() + "user/" + section + "" + username.ToLower() + ".aspx";
        }

        return _url;
    }
    // Generate Video Preview Url
    public static string Prepare_Video_Preview_Url(long videoid, string title, bool isadmin)
    {
        string _title = "";
        int maxium_length = Site_Settings.Maxiumum_Dynamic_Url_Length;
        if(title.Length>maxium_length && maxium_length > 0)
            _title = title.Substring(0,maxium_length);
        else if (title.Length < 3)
            _title = "preview-video";
        else
            _title = title;

        _title = UtilityBLL.ReplaceSpaceWithHyphin(_title.Trim().ToLower());
      
        string _url="";
        if (!isadmin)
            _url = Config.GetUrl("video/" + videoid + "/" + _title + ".aspx");
        else
            _url = Config.GetUrl("adm/sc/videos/VideoDetail.aspx?vid=" + videoid + "");
        return _url;
    }

    // Generate Audio Preview Url
    public static string Prepare_Audio_Preview_Url(long audioid, string title, bool isadmin)
    {
        string _title = "";
        int maxium_length = Site_Settings.Maxiumum_Dynamic_Url_Length;
        if (title.Length > maxium_length && maxium_length > 0)
            _title = title.Substring(0, maxium_length);
        else if (title.Length < 3)
            _title = "preview-audio";
        else
            _title = title;

        _title = UtilityBLL.ReplaceSpaceWithHyphin(_title.Trim().ToLower());
      
        string _url = "";
        if (!isadmin)
           _url = Config.GetUrl("audio/" + audioid + "/" + _title + ".aspx");
        else
            _url = Config.GetUrl("adm/sc/videos/VideoDetail.aspx?vid=" + audioid + "");
        return _url;
    }

    // Generate Photo Preview Url
    public static string Prepare_Photo_Preview_Url(long id, string title, bool isadmin)
    {
        string _url = "";
        if (!isadmin)
            _url = Config.GetUrl("photo/" + id + ".aspx");
        else
            _url = Config.GetUrl("adm/sc/photos/Detail.aspx?pid=" + id + "");
        return _url;
    }
     
    public static string Prepare_PhotoGallery_Preview_Url(long id, long selectedimageid,string title, bool isadmin)
    {

        string _title = "";
        int maxium_length = Site_Settings.Maxiumum_Dynamic_Url_Length;
        if (title.Length > maxium_length && maxium_length > 0)
            _title = title.Substring(0, maxium_length);
        else if (title.Length < 3)
            _title = "preview-gallery";
        else
            _title = title;

        _title = UtilityBLL.ReplaceSpaceWithHyphin(_title.Trim().ToLower());

        string _url = "";
        if (!isadmin)
        {
            if(selectedimageid>0)
                _url = Config.GetUrl("gallery/" + id + "/" + _title + "/" + selectedimageid + ".aspx");
            else
                _url = Config.GetUrl("gallery/" + id + "/" + _title + ".aspx");
        }
        else
            _url = Config.GetUrl("adm/sc/galleries/Detail.aspx?gid=" + id + "");
        return _url;
    }

    public static string Prepare_MediaAlbum_Preview_Url(long id, long selectedimageid, string title, bool isadmin)
    {

        string _title = "";
        int maxium_length = Site_Settings.Maxiumum_Dynamic_Url_Length;
        if (title.Length > maxium_length && maxium_length > 0)
            _title = title.Substring(0, maxium_length);
        else if (title.Length < 3)
            _title = "preview-album";
        else
            _title = title;

        _title = UtilityBLL.ReplaceSpaceWithHyphin(_title.Trim().ToLower());

        string _url = "";
        if (!isadmin)
        {
            if (selectedimageid > 0)
                _url = Config.GetUrl("album/" + id + "/" + _title + "/" + selectedimageid + ".aspx");
            else
                _url = Config.GetUrl("album/" + id + "/" + _title + ".aspx");
        }
        else
            _url = Config.GetUrl("adm/sc/album/Detail.aspx?gid=" + id + "");
        return _url;
    }

      
    // Return website logo url - url used for sending to Facebook (share
    public static string Return_Website_Logo_Url()
    {
        return Config.GetUrl("images/logo.gif");
        
    }

    public static string Return_Photo_DownloadUrl(long id)
    {
        return Config.GetUrl("get/" + id + ".aspx");
    }

    public static string Retun_User_Profile_Thumb_Url(string username, string picturename,int iscloud)
    {
        string URL = "";
        if (picturename.Contains("http"))
            URL = picturename;
        else if (picturename != "none")
            URL = UrlConfig.Return_Photo_Url(username, picturename, 0, iscloud);
        else
            URL = Config.GetUrl() + "images/dmember.png";

        return URL;
    }

    public static string Return_Gallery_Thumb_url(string username, string picturename,int type, int iscloud)
    {
        string URL = "";
        if (picturename.Contains("http"))
            URL = picturename;
        else if (picturename != "none")
            URL = UrlConfig.Return_Photo_Url(username, picturename,type, iscloud);
        else
            URL = Config.GetUrl() + "groups/images/group_icon.gif";

        return URL;
    }

    public static string Return_Group_Thumb_url(string username, string picturename)
    {
        string URL = "";
        if (picturename.Contains("http"))
            URL = picturename;
        else if (picturename != "none")
            URL = Config.GetUrl() + "contents/member/" + username + "/groups/Thumbs/" + picturename;
        else
            URL = Config.GetUrl() + "groups/images/group_icon.gif";

        return URL;
    }

    public static string Return_Photo_Url(string username, string picturename, int type, int iscloud)
    {
        if (iscloud == 1) // media stored in cloud storage
            return Return_Cloud_Photo_Url(picturename, type);
        else
        {
            // type = 0: thumb, 1: mid thumb, 2: original
            string URL = "";
            string Imagetype = ""; // original
            switch (type)
            {
                case 0:
                    Imagetype = "thumbs/";
                    break;
                case 1:
                    Imagetype = "midthumbs/";
                    break;
            }
            if (picturename.Contains("http"))
                URL = picturename;
            else if (picturename != "none")
                URL = Config.GetUrl() + "contents/member/" + username + "/photos/" + Imagetype + "" + picturename;
            else
                URL = Config.GetUrl() + "images/dmember.png";
            return URL;
        }
    }

    public static string Return_Cloud_Photo_Url(string picturename, int type)
    {
        return "";
        //string URL = "";
        //switch(type)
        //{
        //    case 0:
        //        URL = CloudSettings.Photo_ThumbBucketUrl;
        //        break;
        //    case 1:
        //         URL = CloudSettings.Photo_MedBucketUrl;
        //         break;
        //    case 2:
        //         URL = CloudSettings.Photo_OriginalBucketUrl;
        //         break;
        //}
        //return URL + "" + picturename;
    }
     
    public static string Return_Photo_Physical_Url(string username, string picturename, int type, int iscloud)
    {
        if (iscloud == 1) // media stored in cloud storage
            return Return_Cloud_Photo_Url(picturename, type);
        else
        {
            // type = 0: thumb, 1: mid thumb, 2: original
            string URL = "";
            string Imagetype = ""; // original
            switch (type)
            {
                case 0:
                    Imagetype = "thumbs/";
                    break;
                case 1:
                    Imagetype = "midthumbs/";
                    break;
            }
            if (picturename != "none")
                URL = HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath) + "\\contents\\member\\" + username + "\\photos\\" + Imagetype + "" + picturename;
            else
                URL = HttpContext.Current.Server.MapPath(HttpContext.Current.Request.ApplicationPath) + "groups\\images\\group_icon.gif";
            return URL;
        }
    }

    public static string Return_Video_Playlist_Url(long playlistid)
    {
        return Config.GetUrl() + "video/Playlist.aspx?plid=" + playlistid;
    }


    // Generate Group Preview Url
    public static string Prepare_Group_Preview_Url(long id, string name, bool isadmin,int accesstype)
    {
        // access type = 0: main url, 1: group media (video, audio, photos), 2: group members, 3: group topics
        string _url = "";
        if (!isadmin)
            switch (accesstype)
            {
                case 0:
                    _url = Config.GetUrl("group/" + id + ".aspx");
                    break;
                case 2:
                    _url = Config.GetUrl("group/members/" + id + ".aspx");
                    break;
            }
        else
        {
            switch (accesstype)
            {
                case 0:
                    _url = Config.GetUrl("adm/sc/groups/Detail.aspx?gid=" + id + "");
                    break;
                case 1:
                    _url = Config.GetUrl("adm/sc/groups/Videos.aspx?gid=" + id + "");
                    break;
                case 2:
                    _url = Config.GetUrl("adm/sc/groups/Members.aspx?gid=" + id + "");
                    break;
                case 3:
                    _url = Config.GetUrl("adm/sc/groups/Topics.aspx?gid=" + id + "");
                    break;
            }
          
        }
        return _url;
    }

    // Generate Group Post Url
    public static string Prepare_Group_Post_Url(long groupid, long id, bool isadmin)
    {
        string _url = "";
        if (!isadmin)
            _url = Config.GetUrl("group/post/" + groupid + "/" + id + ".aspx");
        else
            _url = Config.GetUrl("adm/sc/groups/Post.aspx?gid=" + groupid + "&pid=" + id);
        return _url;
    }

    public static string Return_Group_Thumb_Url(string username, string picturename, int iscloud)
    {
        string URL = "";
        if (picturename.Contains("http"))
            URL = picturename;
        else if (picturename != "none")
            URL = Config.GetUrl() + "contents/member/" + username + "/groups/thumbs/" + picturename;
        else
            URL = Config.GetUrl() + "groups/images/group_icon.gif";

        return URL;
    }

    /*************************************** */
    /************************** UPLOAD CONTENT PATH SETTINGS */
    // Photo Uploading Path
    public static string Photo_Upload_Path(string username,int type)
    {
        // type: 0 --/ Default
        // type: 1 --/ Mid thumb
        // type: 2 --/ Thumb
        string pathsettings ="";
        switch (type)
        {
            case 1:
                pathsettings = "/midthumbs";
                break;
            case 2:
                pathsettings = "/thumbs";
                break;
        }
        return HttpContext.Current.Server.MapPath("~/contents/member/" + username + "/photos" + pathsettings);
    }
    // Video Uploading Path
    public static string Video_Upload_Path(string username, string pathsettings)
    {
        //pathsettings = "/midthumbs";
        return HttpContext.Current.Server.MapPath("~/contents/member/" + username + "" + pathsettings);
    }

    public static string Return_User_Profile_Photo(string username, string picturename, int type, int iscloud)
    {
        if (iscloud == 1) // media stored in cloud storage
            return Return_Cloud_Photo_Url(picturename, type);
        else
        {
            // type = 0: thumb, 1: mid thumb, 2: original
            string URL = "";
            string Imagetype = ""; // original
            switch (type)
            {
                case 0:
                    Imagetype = "thumbs/";
                    break;
                case 1:
                    Imagetype = "midthumbs/";
                    break;
            }
            if (picturename.Contains("http"))
                URL = picturename;
            else if (picturename != "none")
                URL = Config.GetUrl() + "contents/member/" + username + "/photos/" + Imagetype + "" + picturename;
            else
                URL = Config.GetUrl() + "images/dmember.png";
            return URL;
        }
    }

}