﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.GData.YouTube;
using Google.GData.Extensions.MediaRss;
using Google.YouTube;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;

public partial class adm_sc_engine_youtube_YoutubeSDK : System.Web.UI.Page
{
    private int NewUpdates = 0;
    private int Update_Counter = 0;
   
    private string ApplicationName = "";
    private string DeveloperID = "";
    private string _categoryid = "";
    private int _isapprove = 0;
    private string _username = "";
    private bool _isblog = false;

    public string CategoryID
    {
        set { _categoryid = value; }
        get { return _categoryid; }
    }

    public int isApproved
    {
        set { _isapprove = value; }
        get { return _isapprove; }
    }

    public string UserName
    {
        set { _username = value; }
        get { return _username; }
    }

    public bool isBlog
    {
        set { _isblog = value; }
        get { return _isblog; }
    }

    YouTubeRequestSettings settings = null;
    YouTubeRequest req = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        ApplicationName = Site_Settings.Yt_Application_Name;
        DeveloperID = Site_Settings.Yt_Developer_Key;
        settings = new YouTubeRequestSettings(ApplicationName, DeveloperID);
        req = new YouTubeRequest(settings);

        if (!Page.IsPostBack)
        {           
            Process();
        }
    }

    private void Process()
    {
        string term = "";
        if (Request.Params["usr"] != null)
        {
            this.UserName = Request.Params["usr"].ToString();
        }
        if (Request.Params["cid"] != null)
        {
            this.CategoryID = Request.Params["cid"].ToString();
        }
        if (Request.Params["term"] != null)
        {
            term = Request.Params["term"].ToString();
        }
        if (Request.Params["approve"] != null)
        {
            this.isApproved = Convert.ToInt32(Request.Params["approve"].ToString());
        }
       
       

        // Search Specific
        YouTubeQuery query = new YouTubeQuery(YouTubeQuery.DefaultVideoUri);
        //order results by the number of views (most viewed first)
        query.OrderBy = "published"; //relevance, viewCount, published, or rating.
        if (Request.Params["vc"] != null)
        {
            switch (Convert.ToInt32(Request.Params["vc"]))
            {
                case 0:
                    // relevance
                    query.OrderBy = "relevance";
                    break;
                case 1:
                    // viewcount
                    query.OrderBy = "viewCount";
                    break;
                case 2:
                    // published
                    query.OrderBy = "published";
                    break;
                case 3:
                    // rating
                    query.OrderBy = "rating";
                    break;
            }
        }
        // search for puppies and include restricted content in the search results
        // query.SafeSearch could also be set to YouTubeQuery.SafeSearchValues.Moderate
        query.Query = ReplaceHyphinWithPlus(term.ToLower());
        query.SafeSearch = YouTubeQuery.SafeSearchValues.None;
        // query.Formats = YouTubeQuery.VideoFormat.Embeddable;
        //query.NumberToRetrieve = 10;
        query.Time = YouTubeQuery.UploadTime.Today;
        if (Request.Params["yt_user"] != null)
        {
            query.Uploader = Request.Params["yt_user"].ToString();
        }
        query.Uploader = "";
        if (Request.Params["upd"] != null)
        {
            switch (Convert.ToInt32(Request.Params["upd"].ToString()))
            {
                case 0:
                    // today
                    query.Time = YouTubeQuery.UploadTime.Today;
                    break;
                case 1:
                    // this week
                    query.Time = YouTubeQuery.UploadTime.ThisWeek;
                    break;
                case 2:
                    // this month
                    query.Time = YouTubeQuery.UploadTime.ThisMonth;
                    break;
                case 3:
                    // all time
                    query.Time = YouTubeQuery.UploadTime.AllTime;
                    break;
            }
        }
        if (Request.Params["yt_cat"] != null)
        {
            AtomCategory category1 = new AtomCategory(Request.Params["yt_cat"].ToString(), YouTubeNameTable.CategorySchema);
            query.Categories.Add(new QueryCategory(category1));
        }
        if (Request.Params["tags"] != null)
        {
            string tags = Request.Params["tags"].ToString();
            if (tags.Contains(","))
            {
                // process tags
                string[] arr = tags.ToString().Split(char.Parse(","));
                int j = 0;
                AtomCategory tlist = null;
                for (j = 0; j <= arr.Length - 1; j++)
                {
                    tlist = new AtomCategory(arr[j].ToString().ToLower().Trim(), YouTubeNameTable.KeywordSchema);
                    query.Categories.Add(new QueryCategory(tlist));
                }
            }
            else
            {
                AtomCategory tg = new AtomCategory(tags.ToLower().Trim(), YouTubeNameTable.KeywordSchema);
                query.Categories.Add(new QueryCategory(tg));
            }
        }

        if (Request.Params["ext"] != null)
        {
            // extended search enabled
            query.StartIndex = 1;
            query.NumberToRetrieve = 25;
            Update_Counter = 1; // just to start while counter
            while (Update_Counter > 0)
            {
                Update_Counter = 0;
                Feed<Video> videoFeed = req.Get<Video>(query);
                query.StartIndex = query.StartIndex + 25;
                ProcessVideoList(videoFeed);
            }
        }
        else
        {
            // normal search enabled
            Feed<Video> videoFeed = req.Get<Video>(query);
            ProcessVideoList(videoFeed);
        }
        result.InnerHtml = NewUpdates + " Updates Process Successfully";
        NewUpdates = 0;
      
    }

    private void ProcessVideoList(Feed<Video> feed)
    {
        foreach (Video entry in feed.Entries)
        {
            ProcessVideoEntry(entry);
        }
    }

    private void ProcessVideoEntry(Video video)
    {
        try
        {
            //StringBuilder str = new StringBuilder();

            //if (video.YouTubeEntry.Location != null)
            //{
            //    str.Append("Latitude: " + video.YouTubeEntry.Location.Latitude + "<br />");
            //    str.Append("Longitude: " + video.YouTubeEntry.Location.Longitude + "<br />");
            //}
            //if (video.Media != null && video.Media.Rating != null)
            //{
            //    str.Append("Restricted in: " + video.Media.Rating.Country + "<br />");
            //}
            string videoid = video.Id;
            if (videoid.Contains(":"))
            {
                videoid = videoid.Remove(0, videoid.LastIndexOf(":") + 1);
            }
            string video_watch_id = "/watch?v=" + videoid;
            if (!VideoBLL.Check_YOUTUBE_ID(video_watch_id))
            {
                if (!video.IsDraft)
                {
                    string title = video.Title;
                    string description = video.Description;
                  
                    string thumburl = "";
                    ArrayList thumb_urls = new ArrayList();
                    foreach (MediaThumbnail thumbnail in video.Thumbnails)
                    {
                        thumb_urls.Add(thumbnail.Url);
                        // str.Append("\tThumbnail URL: " + thumbnail.Url + "<br />");
                        // str.Append("\tThumbnail time index: " + thumbnail.Time + "<br />");
                    }
                    if (thumb_urls.Count > 1)
                    {
                        int count = Convert.ToInt32(thumb_urls.Count / 2);
                        thumburl = thumb_urls[count].ToString();
                    }
                    else
                    {
                        thumburl = thumb_urls[0].ToString();
                    }
                    string duration_sec = "";
                    foreach (Google.GData.YouTube.MediaContent mediaContent in video.Contents)
                    {
                        // str.Append("\tMedia Location: " + mediaContent.Url + "<br />");
                        // str.Append("\tMedia Type: " + mediaContent.Format + "<br />");
                        duration_sec = mediaContent.Duration;
                    }
                    // process and add video
                    string flv_filename = "";
                    string original_filename = "";
                    string thumb_filename = "";
                    string duration = "";

                    // set video actions : 1 -> on, 0 -> off
                    int isenabled = 1;
                    int ispublished = 1;
                    int isreviewed = isApproved;
                    int isprivate = 0;
                    int isresponse = 0;
                    int isexternal = 1;
                    string flv_url = "none";
                    //string _embed = Generate_Embed_Script(videoid);
                    string _embed = videoid;
                    if (!Config.isAutomativeApproval())
                        isreviewed = 0;

                    string ipaddress = Request.ServerVariables["REMOTE_ADDR"].ToString();
                    string username = "";
                    username = this.UserName;

                   
                    //string _tags = taglist.ToString();
                    //if (_tags.Length > 200)
                    //    _tags = _tags.Substring(0, 200);

                    // remove <a tags from description
                    Regex _href = new Regex(@"<a[^<]+?>", RegexOptions.Singleline); // remove <a href.....>
                    Regex _hrefend = new Regex(@"</a>", RegexOptions.Singleline); // remove </a>
                    description = _href.Replace(description, string.Empty);
                    description = _hrefend.Replace(description, string.Empty);

                    string _des = description;
                    if (_des.Length > 2000)
                        _des = _des.Substring(0, 2000);

                    Regex _regext = new Regex("'", RegexOptions.Singleline);
                    _des = _regext.Replace(_des, "\'");
                    title = _regext.Replace(title, "\'");
                    //_tags = _regext.Replace(_tags, "\'");
                    //string _taglist = _regext.Replace(taglist.ToString(), "\'");
                    int istagsreviewed = 1; // tags not reviewed yet
                    Video_Struct vd = new Video_Struct();
                    vd.CategoryID = 0; // store categoryname or term instead of category id
                    vd.Categories = CategoryID;
                    vd.UserName = username;
                    vd.Title = title;
                    vd.Description = _des;
                    vd.Tags = "";
                    vd.Duration = duration;
                    vd.Duration_Sec = Convert.ToInt32(duration_sec);
                    vd.OriginalVideoFileName = original_filename;
                    vd.VideoFileName = flv_filename;
                    vd.ThumbFileName = thumb_filename;
                    vd.isPrivate = isprivate;
                    vd.isEnabled = isenabled;
                    vd.Response_VideoID = 0;
                    vd.isResponse = isresponse;
                    vd.isPublished = ispublished;
                    vd.isReviewed = isreviewed;
                    vd.FLV_Url = flv_url;
                    vd.Thumb_Url = thumburl;
                    vd.Embed_Script = _embed;
                    vd.isExternal = isexternal;
                    vd.IPAddress = ipaddress;
                    vd.Type = 0;
                    vd.YoutubeID = video_watch_id;
                    vd.isTagsreViewed = istagsreviewed;
                    VideoBLL.Process_Info(vd, false);
                    NewUpdates++;
                    Update_Counter++;
                }
            }
            //if (video.IsDraft)
            //{
            //    str.Append("Video is not live." + "<br />");
            //    string stateName = video.Status.Name;
            //    if (stateName == "processing")
            //    {
            //        str.Append("Video is still being processed." + "<br />");
            //    }
            //    else if (stateName == "rejected")
            //    {
            //        Console.Write("Video has been rejected because: " + "<br />");
            //        str.Append(video.Status.Value + "<br />");
            //        Console.Write("For help visit: " + "<br />");
            //        str.Append(video.Status.Help + "<br />");
            //    }
            //    else if (stateName == "failed")
            //    {
            //        Console.Write("Video failed uploading because:" + "<br />");
            //        str.Append(video.Status.Value + "<br />");

            //        Console.Write("For help visit: " + "<br />");
            //        str.Append(video.Status.Help + "<br />");
            //    }

            //    if (video.ReadOnly == false)
            //    {
            //        str.Append("Video is editable by the current user." + "<br />");
            //    }

            //    if (video.RatingAverage != -1)
            //    {
            //        str.Append("Average rating: " + video.RatingAverage + "<br />");
            //    }
            //    if (video.ViewCount != -1)
            //    {
            //        str.Append("View count: " + video.ViewCount + "<br />");
            //    }



            //    str.Append("Media:" + "<br />");
            //    foreach (Google.GData.YouTube.MediaContent mediaContent in video.Contents)
            //    {
            //        str.Append("\tMedia Location: " + mediaContent.Url + "<br />");
            //        str.Append("\tMedia Type: " + mediaContent.Format + "<br />");
            //        str.Append("\tDuration: " + mediaContent.Duration + "<br />");
            //    }
            //}
            //return str.ToString();
        }
        catch (Exception ex)
        {
            result.InnerHtml = ex.Message;
        }
    }

    public string ReplaceHyphinWithPlus(string input)
    {
        string str = Regex.Replace(input, @"[\-]", "+");
        return str;
    }

    private string Generate_Embed_Script(string youtubeid)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<object width=\"640\" height=\"385\"><param name=\"movie\" value=\"http://www.youtube.com/v/" + youtubeid + "?fs=1&amp;hl=en_US\"></param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"allowscriptaccess\" value=\"always\"></param><embed src=\"http://www.youtube.com/v/" + youtubeid + "?fs=1&amp;hl=en_US\" type=\"application/x-shockwave-flash\" allowscriptaccess=\"always\" allowfullscreen=\"true\" width=\"640\" height=\"385\"></embed></object>");
        return str.ToString();
    }
}