using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.UI.HtmlControls;
using System.IO;

public partial class admin_secure_modules_abusereport : System.Web.UI.UserControl
{
    int media_type = 0; // 0: video, 1: audio

    public int ContentID
    {
        get
        {
            if (ViewState["ContentID"] != null)
                return (int)ViewState["ContentID"];
            else
                return 0;
        }
        set
        {
            ViewState["ContentID"] = value;
        }
    }

    public long ContentID_Lng
    {
        get
        {
            if (ViewState["ContentID_Lng"] != null)
                return (long)ViewState["ContentID_Lng"];
            else
                return 0;
        }
        set
        {
            ViewState["ContentID_Lng"] = value;
        }
    }

    public long GroupID
    {
        get
        {
            if (ViewState["GroupID"] != null)
                return (long)ViewState["GroupID"];
            else
                return 0;
        }
        set
        {
            ViewState["GroupID"] = value;
        }
    }

    public string Content_Owner
    {
        get
        {
            if (ViewState["Content_Owner"] != null)
                return ViewState["Content_Owner"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["Content_Owner"] = value;
        }
    }

    public int Type
    {
        get
        {
            if (ViewState["Type"] != null)
                return (int)ViewState["Type"];
            else
                return 0;
        }
        set
        {
            ViewState["Type"] = value;
        }
    }

        
    protected void Page_Load(object sender, EventArgs e)
    {
        HideMessage();
      
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (this.ContentID > 0)
            this.ContentID_Lng = (long)this.ContentID;

        BindList();
    }

    private void BindList()
    {
        DataSet ds = AbuseReport.Load_Video_Reports(this.ContentID_Lng, this.Type);
        if (ds.Tables[0].Rows.Count > 0)
        {
            rpt_reports.DataSource = ds.Tables[0];
            rpt_reports.DataBind();
        }
    }

    protected void rpt_reports_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            // nothing
        }
    }
    protected void rpt_reports_ItemCommand(object source, RepeaterCommandEventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }

        LinkButton lnk_cmd = (LinkButton)e.CommandSource;
        string cmd = lnk_cmd.CommandName.ToString();
              
       // string _vid_user = VideoBLL.Get_UserName((int)this.ContentID);
       // string cmd = e.CommandSource.ToString();
        if(cmd=="deletereport")
        {
            // videos
            AbuseReport.Delete(this.ContentID_Lng, this.Type);
            switch (this.Type)
            {
                case 0:
                    // mark video as enabled video
                    int OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(ContentID_Lng, "isenabled"));
                    VideoBLL.Update_IsEnabled(this.ContentID_Lng,OldValue, 1, this.Content_Owner,media_type);
                    Response.Redirect( Config.GetUrl("adm/sc/abuse/Default.aspx?action=reportdeleted"));
                    break;
               
            }
            return;
          
        }
        else if(cmd=="disable")
        {
            switch (this.Type)
            {
                case 0:
                    // videos
                     int OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(ContentID_Lng, "isenabled"));
                    VideoBLL.Update_IsEnabled(this.ContentID_Lng,OldValue, 0, this.Content_Owner,media_type);
                    Response.Redirect( Config.GetUrl("adm/sc/abuse/Default.aspx?action=videodisabled"));
                    break;
                

            }
            return;
        }
        else if(cmd=="deletevideo")
        {
            switch (this.Type)
            {
                case 0:
                    // videos
                    Response.Redirect( Config.GetUrl("adm/sc/videos/videodetail.aspx?vid=" + this.ContentID_Lng + "&action=delete"));
                    break;
              
            }
           
           return;
        }

        BindList();
    }

     private void ShowMessage(string message)
    {
        pnl_error.Visible = true;
        lbl_error.Text = message;
    }

    private void HideMessage()
    {
        pnl_error.Visible = false;
        lbl_error.Text = "";
    }
}
