using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.UI.HtmlControls;
using System.Text;
using System.Collections.Generic;

public partial class adm_sc_videodetail : System.Web.UI.Page
{
    private VideoBLL _mediadalc = new VideoBLL();
    private UtilityBLL _utility = new UtilityBLL();

    private bool isaud = false;

    string title = "";
    public long VideoID
    {
        get
        {
            if (ViewState["VideoID"] != null)
                return int.Parse(ViewState["VideoID"].ToString());
            else
                return 0;
        }
        set
        {
            ViewState["VideoID"] = value;
        }
    }
    

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Request.Params["vid"] != null)
            {
                this.VideoID = int.Parse(Request.Params["vid"].ToString());
              
            }
            else
            {
                Response.Redirect("Default.aspx");
           }

            if (Request.Params["status"] != null)
            {
                if (Request.Params["status"] == "updated")
                {
                    Config.ShowMessageV2(msg, "Video Information Updated", "Success!", 1);
                }
            }
            if (Request.Params["tp"] != null)
                isaud = true;

            // Load information
            Load_Video_Information(this.VideoID);
           
          
            
        }
    }

    private void Load_Video_Information(long VideoID)
    {
        List<Video_Struct> lst = _mediadalc.Get_Information(VideoID);
        if (lst.Count > 0)
        {
            pnl_main.Visible = true;
            // Get information
            title = lst[0].Title;
            DateTime date_added = lst[0].Date_Added;
            string username = lst[0].UserName;
            string description = lst[0].Description;
            int categoryid = lst[0].CategoryID;
            string categoryname = lst[0].CategoryName;
            string tags = lst[0].Tags;
            string flv_url = lst[0].FLV_Url;
            string videofilename = lst[0].VideoFileName;
            string thumb_url = lst[0].Thumb_Url;
            string thumbfilename = lst[0].ThumbFileName;
            long response_videoid = lst[0].Response_VideoID;
            int total_rating = lst[0].Total_Rating;
            double ratings = lst[0].Ratings;
            int views = lst[0].Views;
            int comments = lst[0].Comments;
            int favorites = lst[0].Favorites;
            int responses = lst[0].Responses;
            double avg_rating = lst[0].Avg_Rating;
            // Use Information
            lbl_title.Text = title;
            Page.Title = title;


            // Video Path settings

            string VideoPath = ""; 
            if(lst[0].Type==1)
                VideoPath = Config.Return_MP3_Audio_Url(flv_url, username) + "/" + videofilename;
            else
                VideoPath = Config.Return_FLV_Video_Url(flv_url, username) + "/" + videofilename;
            // Thumbnail Path
            string PictureName = Config.Return_FLV_Video_Url(thumb_url, username) + "/" + thumbfilename;

            //*****************************************************************
            // PLAYER SETUP SCRIPT
            //*****************************************************************
            if (lst[0].Type == 1)
            {
                player1.Provider = "Sound";
                player1.Plugins = "revolt-1";
                player1.Height = 200;
            }
           
            player1.Duration = lst[0].Duration_Sec.ToString();
            player1.Skin = Config.GetUrl("player/skins/bekle/bekle.swf");
          
            // If cloud enabled
            if (lst[0].Embed_Script != "")
            {
                // third party embed video script enabled
                player1.Embed_Script = lst[0].Embed_Script;
            }
            else if (flv_url != "none" && flv_url != "")
            {
                // cloud setup exist
                player1.Provider = "rtmp";
               
                player1.FileName = lst[0].VideoFileName;

            }
            else if (lst[0].VideoFileName.EndsWith("flv"))
            {
                // Enable flv http streaming
                player1.Streamer_File = Config.GetUrl("stream/vsk-flv.ashx?token=" + username);
                player1.Provider = "http";
                player1.FileName = lst[0].VideoFileName;
            }
            else
            {
                // load and play videos normally
                player1.FileName = VideoPath;
            }
            //*****************************************************************
            // CLOSE PLAYER SETUP SCRIPT
            //*****************************************************************

            // video information - > update / display
            video_snap1.VideoID = this.VideoID;
            video_snap1.UserName = username;
            video_snap1.Date_Added = date_added;
            video_snap1.Title = title;
            video_snap1.Description = description;
            video_snap1.Tags = tags;
            video_snap1.CategoryID = categoryid;
            video_snap1.Views = views;
            video_snap1.Comments = comments;
            video_snap1.Favorited = favorites;
            video_snap1.Liked = lst[0].Liked;
            video_snap1.Disliked = lst[0].Disliked;
            video_snap1.isAdult = lst[0].isAdult;
            video_snap1.isFeatured = lst[0].isFeatured;
            video_snap1.isEnabled = lst[0].isEnabled;
            video_snap1.isApproved = lst[0].isReviewed;
            video_snap1.Categories = lst[0].Categories;
            video_snap1.Downloads = lst[0].Downloads;
            video_snap1.Type = lst[0].Type;
            // Video Management
            video_mg1.VideoID = this.VideoID;
            video_mg1.UserName = username;
            if (lst[0].Type==1)
                video_mg1.MediaType = 1;

            // List thumbs editing
            if (lst[0].Type==1)
            {
                lst_thumbs1.Visible = false;
            }
            else
            {
                string thumbname = lst[0].ThumbFileName;
                string thumb_start_index = "";
                if (thumbname.Contains("_"))
                {
                    thumb_start_index = thumbname.Remove(thumbname.LastIndexOf("_"));
                    lst_thumbs1.thumb_start_sequence = thumb_start_index + "_";
                    lst_thumbs1.selected_thumb = thumbname;
                    lst_thumbs1.UserName = username;
                    lst_thumbs1.VideoID = this.VideoID;
                    lst_thumbs1.Thumb_Url = thumb_url;
                }
                else
                {
                    lst_thumbs1.Visible = false;
                }
            }

            //screening content
            screening1.Title = lst[0].Title; 
            screening1.Description = lst[0].Description;
            screening1.Tags = lst[0].Tags;
          
        }
        else
        {
            pnl_main.Visible = false;
            Config.ShowMessageV2(msg, "Video Doesn't Exist", "Error!", 0);
        }
    }

}
