﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

using System.Collections.Generic;
using System.Text;

public partial class myaccount_Default : System.Web.UI.Page
{ 

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // Myaccount top navigation setting
            macc_menu1.ActiveIndex = 6; // Account Settings

            // toggle on | off features
            Toggle_UI();

            if (!Page.User.Identity.IsAuthenticated)
            {
                string redirect_url = Config.GetUrl() + "myaccount/Default.aspx";
                Response.Redirect(Config.GetUrl() + "Login.aspx?ReturnUrl=" + redirect_url);
                return;
            }
            string username = Page.User.Identity.Name;

            // status / error messages
            if (Request.Params["status"] != null)
            {
                switch (Request.Params["status"].ToString())
                {
                    case "success":
                        Config.ShowMessageV2(msg, Resources.vsk.message_myaccount_01, "Success!", 1); //Your account has been created
                        break;
                    case "activated":
                        Config.ShowMessageV2(msg, Resources.vsk.message_myaccount_02, "Success!", 1); //Your account has been activated
                        break;
                }
            }
            

            left_nav1.ActiveIndex = 0;
                        
            // Load user overview
            Load_OverView(username);
        }
    }

    private void Load_OverView(string username)
    {
        List<Member_Struct> _list = members.Fetch_User_Channel(username);
        if (_list.Count > 0)
        {
            // avator setup
            avator_upd21.UserName = username;
            avator_upd21.PhotoName = _list[0].PictureName;

            string usr_channel_url = UrlConfig.Prepare_User_Profile_Url(username, false);
            StringBuilder prf_lf = new StringBuilder();

            string _name = "";
            if (_list[0].FirstName != "" || _list[0].LastName != "")
                _name = _list[0].FirstName + " " + _list[0].LastName;
            else
                _name = username;

            prf_lf.Append("<div class=\"item_pad_2\">\n");
            prf_lf.Append("<a href=\"" + UrlConfig.Prepare_User_Profile_Url(username,false) + "\" class=\"xxmedium-text bold\">" + _name + "</a>");
            prf_lf.Append("</div>\n");

            StringBuilder info = new StringBuilder();
            info.Append(_list[0].Gender);
            if (_list[0].RelationshipStatus != "")
                info.Append(", " + _list[0].RelationshipStatus);
            if (_list[0].HometTown != "" || _list[0].CurrentCity != "")
            {
                if (_list[0].CurrentCity != "")
                    info.Append(", " + _list[0].HometTown);
                else
                    info.Append(", " + _list[0].CurrentCity);
            }
            if (_list[0].Zipcode != "")
                info.Append(", " + _list[0].Zipcode);
            info.Append(", " + _list[0].CountryName);

            prf_lf.Append("<div class=\"item\">\n");
            prf_lf.Append("<span class=\"normal-text light\">" + info.ToString() + "</span>\n");
            string views = "0";
            if (_list[0].Views > 0)
                views = string.Format("{0:#,###}", _list[0].Views);
            prf_lf.Append("<br /><span class=\"normal-text light\">" + Resources.vsk.channelviews + "</span> <strong>" + views + "</strong><br />");
            prf_lf.Append("</div>\n");
            
            ovr_first.InnerHtml = prf_lf.ToString();
        }
    }

    private void Toggle_UI()
    {
        string _rooturl = Config.GetUrl();

        StringBuilder str = new StringBuilder();
        if (Config.isVideos())
        {
            str.Append("<div style=\"float:left; width:24%; padding-right:7px;\">\n");
            str.Append("<div class=\"ajax_out_box ui-corner-all\">\n");
            str.Append(Generate_Video_Links(_rooturl));
            str.Append("</div>\n");
            str.Append("</div>\n");
        }
       
      
        str.Append("<div class=\"clear\"></div>\n");

        lst.InnerHtml = str.ToString();
      
        //// toggle on | off messaging center
        //if (!Config.isFeature_Messaging())
        //{
        //    inb.Visible = false;
        //}
        //// toggle on | off audio feature
        //if (!Config.isAudios())
        //{
        //   isaudio.Visible = false;
        //}
        //// toggle on | off photo feature
        //if (!Config.isPhotos())
        //{
        //    isphotos.Visible = false;
        //}
        //// toggle on | off blog feature
        //if (!Config.isBlogs())
        //{
        //    isblogs.Visible = false;
        //}
        //// toggle on | off mycommunities feature
        //if (!Config.isGroups())
        //{
        //    isgroups.Visible = false;
        //}
    }

    private string Generate_Video_Links(string url)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
        str.Append("<span class=\"xxmedium-text bold\">" + Resources.vsk.videos + "</span></div>\n");
        str.Append("<ul>\n");
        str.Append("<li><a href=\"" + url + "myaccount/myvideos.aspx\">My Videos</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/my_liked_videos.aspx\">" + Resources.vsk.liked + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/myfavorites.aspx\">" + Resources.vsk.favorites + "</a></li>\n");
        if (Config.isFeature_Playlist())
           str.Append("<li><a href=\"" + url + "myaccount/myplaylists.aspx\">" + Resources.vsk.playlists + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/albums/\">My Albums</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/albums/like.aspx\">My Liked Albums</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/albums/favorites.aspx\">My Favorited Albums</a></li>\n");
        str.Append("</ul>\n");
        return str.ToString();
    }

    private string Generate_Audio_Links(string url)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
        str.Append("<span class=\"xxmedium-text bold\">" + Resources.vsk.audio + "</span></div>\n");
        str.Append("<ul>\n");
        str.Append("<li><a href=\"" + url + "myaccount/audio/\">My Audio Files</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/audio/myfavorites.aspx\">" + Resources.vsk.favoritedaudios + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/audio/my_liked_audio.aspx\">" + Resources.vsk.myliked + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/audio/albums/\">My Albums</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/audio/albums/like.aspx\">My Liked Albums</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/audio/albums/favorites.aspx\">My Favorited Albums</a></li>\n");
        str.Append("</ul>\n");
        return str.ToString();
    }

    private string Generate_Photos_Links(string url)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
        str.Append("<span class=\"xxmedium-text bold\">" + Resources.vsk.photos + "</span></div>\n");
        str.Append("<ul>\n");
        str.Append("<li><a href=\"" + url + "myaccount/photos/\">" + Resources.vsk.home + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/photos/mygalleries.aspx\">" + Resources.vsk.mygalleries + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/photos/myphotos.aspx\">" + Resources.vsk.myphotos + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/photos/my_liked_photos.aspx\">My Liked Photos</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/photos/my_liked_galleries.aspx\">My Liked Galleries</a></li>\n");
        str.Append("</ul>\n");
        return str.ToString();
    }

    private string Generate_QA_Links(string url)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
        str.Append("<span class=\"xxmedium-text bold\">Q&amp;A</span></div>\n");
        str.Append("<ul>\n");
        str.Append("<li><a href=\"" + url + "myaccount/qa/\">My Questions</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/qa/answers.aspx\">My Answers</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/qa/favorites.aspx\">" + Resources.vsk.myfavorites + "</a></li>\n");
        str.Append("<li><a href=\"" + url + "myaccount/qa/liked.aspx\">" + Resources.vsk.liked + "</a></li>\n");
        str.Append("</ul>\n");
        return str.ToString();
    }
}
