﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Web.UI.HtmlControls;

public partial class videos_modules_lst : System.Web.UI.UserControl
{
    // Main Video & Audio Listing Script
    // Date Created 23rd Sept 2011
    // VSK Version 5.7 or later

    #region Properties

    public bool isheading = true;
    public int ItemSpace = 3; // Space between two listing items
    // CSS Properties
    public int BoxTemplate = 0; // 0: Default, 1:  ui header style, 2: default state style, 3: default hover style, 4: ui default active style
    public string BoxCssClass = ""; // main box css style
    public string HeadingCssClass = ""; // main box heading css style

    public string NavigationCssClass = "nav nav-tabs";
    public string NavigationLinkCssClass = "";
    public string NavigationActiveLinkCssClass = "active";
    // New Properties
    public string HeadingTitle = "";
    public bool isListStatus = true; // Show list statistics
    public bool isListNav = true; // Show list navigation (recently added, mostviewed etc)
    public string Term = "";
    public int SearchType = 0; // 0: category match, 1: tag cloud match, 2: category or tag match, 3: broad search (category, tag, title, description)
    public int CategoryID = 0; // Backward compatibility (fetch records based on categoryid instead (vsk 5.6 or older supported) of category term (vsk 5.7 or new supported)
    public string PageTitle = "";
    public string PageDescription = "";
    public int TotalColumns = 4; // show total number of records horizontally
    public long AlbumID = 0; // filter videos or audio files via album
    public string NoRecordFoundText = Resources.vsk.nophotosfound;
    public int isFeatured = 2; // 0: normal, 1: featured, 2: both
    public int isAudio = 0; // 0: video, 1: audio file, 2: both
    public int isAdult = 2; // 0: non adult, 1: adult, 2: both
    public int isPrivate = 3; // 0: public media, 1: private media, 2: unlisted media
    public int isExternal = 3; // 0: website media, 1: embed media, 2: both website and embed, 3: all media files
    public string Order = "date_added desc,views desc, liked desc";
    public bool isCache = false; // cache list of records for specified time interval
    public string Meta_ThumbUrl = "";
    // Author / User Related
    public string UserName = ""; // Load user specific records
    // Action Related
    public int isEnabled = 1; // 1: Only enabled records, 0: Disabled Records, 2: Both enabled and disabled records
    public int isApproved = 1; // 1: Only approved records, 0: Not reviewed records only, 2: Both approved and unapproved records

    // Filter Related
    public int Filter = 0; // (0: All Time, 1: Today Viewed, 2: This Week Viewed, 3: This Month Viewed)
    public int AddedFilter = 0; // 0 All Time, 1: Today Added, 2: This Week Added, 3: This Month Added
    // Archive Related
    public int Month = 0; // month id to filter record based on month
    public int Year = 0; // year to filter records based on year
    // Navigation Urls
    public string Recent_Url = "";
    public string MostViewed_Url = "";
    public string MostFavorited_Url = "";
    public string Toprated_Url = "";
    public string MostCommented_Url = "";
    public string Recent_Text = Resources.vsk.recentlyadded;
    public string Viewed_Text = Resources.vsk.mostviewed;
    public string TopRated_Text = Resources.vsk.toprated;
    public string MostCommented_Text = Resources.vsk.mostcommented;
    // pagination url
    public string DefaultUrl = "";
    public string Pagination_Url = "";
    // pagination filter url 
    public string Filter_DefaultUrl = "";
    public string Filter_Pagination_Url = "";
    // og urls
    public string Thumb_Url = "";
    public bool TopPagination = false;
    public bool ShowTopAds = false;
    public bool ShowBottomAds = false;
    public int AdType = 0; // 0: 468x60, 1: 336x280, 2: 300x250

    // Customized Video Item
    public bool ShowDate = true;
    public bool ShowTitle = true;
    public bool ShowUser = true;
    public bool ShowViews = true;
    public bool ShowDownload = false;
    // Old Properties
    private int _tabindex = 0; // recently added, 1: most viewed, 2: most favorited 3: top rated
    private int _pagenumber = 1;
    private int _totalrecords = 0;
    private int _pagesize = 20;
    public int PageNumber
    {
        get { return _pagenumber; }
        set { _pagenumber = value; }
    }
    public int TotalRecords
    {
        get { return _totalrecords; }
        set { _totalrecords = value; }
    }
    public int PageSize
    {
        get { return _pagesize; }
        set { _pagesize = value; }
    }
    public int TabIndex
    {
        get
        {
            return _tabindex;
        }
        set
        {
            _tabindex = value;
        }
    }

    public int Mode = 0;
    // Version 2.0 Properties
    public int ContentLayout = 0; // 0: content on bottom, 1:content on left side
    public int BoxWidth = 150; // complete width of box
    public int Width = 130;
    public int BoxSpace = 15; // space between each item
    public int Height = 72;
    public int LeftWidth = 45; // % width of left side of box
    public int RightWidth = 54; // % width of right side of box
    public bool isHoverEffect = false; // hover effect on mouse move
    public int TitleLength = 35; // max length of title to show
    public bool isAdmin = false; // show admin mode

    public bool EnableSearch = false;
    public string SearchPlaceHolder = "Search Videos";
    public string SearchUrl // keep it in viewstate to avoid postpack issue
    {
        get
        {
            if (ViewState["SearchUrl"] != null)
                return ViewState["SearchUrl"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["SearchUrl"] = value;
        }
    }

    // Group Related Features
    public long GroupID = 0; // if greater then load group photos
    public int GroupStatus = 0; // 0: approved, 1: not approved

    // Advance Options
    public bool LoadFavorites = false;
    public bool LoadLiked = false;


    #endregion

    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (EnableSearch)
        {
            txt_search.Attributes.Add("placeholder", this.SearchPlaceHolder);
            pnl_search.Visible = true;
        }
        else
            pnl_search.Visible = false;

        // prepare box templates
        if (this.BoxCssClass == "")
            PrepareBoxTemplates();

        if (!Page.IsPostBack)
        {
            // Pagination
            if (Request.Params["p"] != null && Request.Params["p"] != "")
            {
                this.PageNumber = Convert.ToInt32(Request.Params["p"]);
            }

            if (!this.isListNav)
                lnav.Visible = false;
            else
            {
                lnav.Visible = true;
                // Set Active Navigation
                Set_Nav_CSS();
            }

            if (!this.isListStatus)
                lstat.Visible = false;

            // process list advertisement
            Process_Ads();

            // Bind List
            BindList();

            // Set page title and option
            Set_Title();

        }
    }

    private void BindList()
    {
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        // query
        Video_Struct query = new Video_Struct();
        query.Term = this.Term;
        query.isFeatured = this.isFeatured;
        query.Type = this.isAudio;
        query.UserName = this.UserName;
        query.Month = this.Month;
        query.Year = this.Year;
        query.Filter = this.Filter;
        query.isEnabled = this.isEnabled;
        query.isReviewed = this.isApproved;
        query.isPrivate = this.isPrivate;
        query.isAdult = this.isAdult;
        query.isExternal = this.isExternal;
        query.Order = this.Order;
        query.PageSize = this.PageSize;
        query.SearchType = this.SearchType;
        query.DateFilter = this.AddedFilter;
        query.isCache = this.isCache;
        query.Mode = this.Mode;
        query.GalleryID = this.AlbumID;
        query.PageNumber = this.PageNumber;
        query.isPublished = 1; // only published videos
        query.LoadFavorites = this.LoadFavorites;
        query.LoadLiked = this.LoadLiked;
        VideoBLL vbll = new VideoBLL();

        this.TotalRecords = vbll.Cache_Count_Videos_V4(query);
        if (this.TotalRecords == 0)
        {
            // no records found
            this.Meta_ThumbUrl = UrlConfig.Return_Website_Logo_Url();
            pg.Visible = false;
            pg_top.Visible = false;
            str.Append("<div class=\"bx_norecord\">");
            str.Append("<h4>" + this.NoRecordFoundText + "</h4>");
            str.Append("</div>");
            lst.InnerHtml = str.ToString();

            return;
        }

        List<Video_Struct> _list = null;
        _list = vbll.Load_Videos_V4(query);
   
        if (_list.Count > 0)
        {
            if (Config.Return_PaginationType() == 2)
            {
                // sql server 2000 compatibility
                this.TotalRecords = _list.Count;
            }

            // Maximum Pagination Restriction for Main Listing
            int maximum_allowed_records = Config.Get_Maximum_Pagination_Links() * this.PageSize;
            if (this.TotalRecords > maximum_allowed_records)
                this.TotalRecords = maximum_allowed_records;

            if (this.isListStatus)
            {
                // List Statistic Display
                list_stat1.TotalRecords = this.TotalRecords;
                list_stat1.PageSize = this.PageSize;
                list_stat1.PageNumber = this.PageNumber;
            }
            else
            {
                // disable showing list status on top of page
                lstat.Visible = false;
            }

            // Pagination Url Setup
            // Bottom Pagination
            if (this.TotalRecords > this.PageSize)
            {
                pagination1.TotalRecords = this.TotalRecords;
                pagination1.PageSize = this.PageSize;
                pagination1.PageNumber = this.PageNumber;
                pagination1.Default_Url = this.DefaultUrl;
                pagination1.Pagination_Url = this.Pagination_Url;
                if (this.Filter > 0)
                {
                    pagination1.isFilter = true;
                    pagination1.Filter_Default_Url = this.Filter_DefaultUrl;
                    pagination1.Filter_Pagination_Url = this.Filter_Pagination_Url;
                }
                pagination1.BindPagination();
                if (TopPagination)
                {
                    // Top Pagination Enabled
                    pagination2.TotalRecords = this.TotalRecords;
                    pagination2.PageSize = this.PageSize;
                    pagination2.PageNumber = this.PageNumber;
                    pagination2.Default_Url = this.DefaultUrl;
                    pagination2.Pagination_Url = this.Pagination_Url;
                    if (this.Filter > 0)
                    {
                        pagination2.isFilter = true;
                        pagination2.Filter_Default_Url = this.Filter_DefaultUrl;
                        pagination2.Filter_Pagination_Url = this.Filter_Pagination_Url;
                    }
                    pagination2.BindPagination();
                }
                else
                {
                    pg_top.Visible = false;
                }
            }
            else
            {
                pg.Visible = false;
                pg_top.Visible = false;
            }
            int i = 0;
            int counter = 0;
            // Testing Values
            //this.TotalColumns = 1;
            //this.ContentLayout = 1;
            //this.BoxWidth = 0;
            //this.isHoverEffect = true;
            //this.LeftWidth = 25;
            //this.RightWidth = 74;
            //this.TitleLength = 0;
            VideoItem video = new VideoItem();
            for (i = 0; i <= _list.Count - 1; i++)
            {
                counter = counter + 1;
                if (counter >= this.TotalColumns)
                {
                    counter = 0;
                    video.BreakLine = true;
                }
                // set og:thumb_url

                // generate thumb rotator script for single video item  
                if (this.isAudio == 0 && _list[i].Embed_Script == "") // no video added through embed script
                    rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[i].ThumbFileName));
                // single comment item
                video.Type = this.isAudio;
                video.ShowDate = this.ShowDate;
                video.ShowTitle = this.ShowTitle;
                video.ShowAuthor = this.ShowUser;
                video.ShowViews = this.ShowViews;
                video.ShowDownloads = this.ShowDownload;
                video.Width = this.Width;
                video.Height = this.Height;
                video.isAdmin = this.isAdmin;
                video.isHoverEffect = this.isHoverEffect;
                video.BoxSpace = this.BoxSpace;
                
                video.TitleLength = this.TitleLength;
                // two level video listing
                video.ContentLayout = this.ContentLayout;
                video.BoxWidth = this.BoxWidth;
                video.LeftWidth = this.LeftWidth; // %
                video.RightWidth = this.RightWidth; // %
                //video.DateFormat = 2;
                //video.ShowDescription = true;
                //video.DescriptionLength = 200;
                //video.ShowTags = true;
                //video.ShowCategories = true;
                //video.Showliked = true;
                //video.ShowDisliked = true;
                //video.ShowApproved = true;
                //video.ShowDisabled = true;
                //video.ShowAdult = true;
                //video.ShowComments = true;
                //video.ShowEditLink = true;
                //video.ShowFeatured = true;
                //video.EditLinkUrl = "http://www.abc.com";
                //video.BoxCssClass = "wiget_item bx_br_bt";
                //_list[i].Tags = "sample,apple,banana";
                //video.CategoriesLength = 30;
                //video.CategoryCaption = "Categories: ";
                //_list[i].Categories = "apple,box animation,another, first, fire, hover effect, mystry, biology, shark, fish";
                //_list[i].Description = "this is sample gallery demonstration to view how everything is working";
                //video.ShowDescription = true;
                if (this.isFeatured == 0 && _list[i].isFeatured == 1)
                {                    
                    video.isAltColor = true;
                    //med.isAltColor = true;
                }
                video.Type = this.isAudio;
                // generate list
                str.Append(video.Process(_list[i]));
            }
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            if (this.isAudio == 0)
                str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
        }
        else
        {
            this.Meta_ThumbUrl = "";
            pg.Visible = false;
            str.Append("<div class=\"bx_norecord\">");
            str.Append("<h4>" + this.NoRecordFoundText + "</h4>");
            str.Append("</div>");
        }

        lst.InnerHtml = str.ToString();


    }

    private void Process_Ads()
    {
        int adtypeid = 3; // 468x60
        if (this.ShowTopAds || this.ShowBottomAds)
        {
            switch (this.AdType)
            {
                case 0:
                    adtypeid = 3;
                    break;
                case 1:
                    adtypeid = 13;
                    break;
                case 2:
                    adtypeid = 15;
                    break;
            }
        }
        if (this.ShowTopAds)
        {
            // Show Top Ads
            tadv.InnerHtml = AdsBLL.Return_Ad_Script(adtypeid);
        }
        else
        {
            tadv.Visible = false;
        }

        if (this.ShowBottomAds)
        {
            // Show Bottom Ads
            badv.InnerHtml = AdsBLL.Return_Ad_Script(adtypeid);
        }
        else
        {
            badv.Visible = false;
        }
    }

    private void Set_Nav_CSS()
    {
        StringBuilder str = new StringBuilder();
        string rec_css = "";
        string mv_css = "";
        string tp_css = "";
        string mf_css = "";
        string mc_css = "";
        if (this.NavigationLinkCssClass != "")
        {
            rec_css = " class=\"" + this.NavigationLinkCssClass + "\"";
            mv_css = " class=\"" + this.NavigationLinkCssClass + "\"";
            tp_css = " class=\"" + this.NavigationLinkCssClass + "\"";
            mf_css = " class=\"" + this.NavigationLinkCssClass + "\"";
            mc_css = " class=\"" + this.NavigationLinkCssClass + "\"";
        }
        switch (this.TabIndex)
        {
            case 0:
                rec_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                break;
            case 1:
                mv_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                break;
            case 2:
                mf_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                break;
            case 3:
                tp_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                break;
            case 4:
                mc_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                break;
        }

        str.Append("<ul class=\"" + NavigationCssClass + "\">\n");
        if (this.Recent_Url != "")
            str.Append("<li" + rec_css + "><a href=\"" + Config.GetUrl(this.Recent_Url) + "\">" + Recent_Text + "</a></li>\n");
        if (this.MostViewed_Url != "")
            str.Append("<li" + mv_css + "><a href=\"" + Config.GetUrl(this.MostViewed_Url) + "\">" + Viewed_Text + "</a></li>\n");
        if (this.Toprated_Url != "")
            str.Append("<li" + tp_css + "><a href=\"" + Config.GetUrl(this.Toprated_Url) + "\">" + TopRated_Text + "</a></li>\n");
        if (this.MostCommented_Url != "")
            str.Append("<li" + mc_css + "><a href=\"" + Config.GetUrl(this.MostCommented_Url) + "\">" + MostCommented_Text + "</a></li>\n");
        str.Append("</ul>\n");
        str.Append("<div class=\"clear\"></div>");
        lnav.InnerHtml = str.ToString();
        //lnav.Attributes.Add("class", NavigationCssClass);
    }

    private void Set_Title()
    {
        string _title = "";
        if (this.PageNumber > 1)
            _title = this.PageTitle + " - Page: " + this.PageNumber;
        else
            _title = this.PageTitle;

        if (this.Thumb_Url != "")
            this.Meta_ThumbUrl = this.Thumb_Url;

        if (this.isheading)
        {
            lbl_status.InnerHtml = _title;
            hd.Attributes.Add("class", HeadingCssClass);
        }
        else
        {
            hd.Visible = false;
        }
        string meta_title = _title;
        string meta_description = this.PageDescription;
        if (PageNumber > 1)
            meta_description = meta_description + ", Page: " + PageNumber;
        MetaTagsBLL.META_StaticPage(this.Page, (HtmlHead)Page.Header, meta_title, meta_description, this.Meta_ThumbUrl, Config.GetUrl(this.DefaultUrl));

    }

    private void PrepareBoxTemplates()
    {
        this.BoxCssClass = UGeneral.Return_Box_Css(this.BoxTemplate);
        this.HeadingCssClass = UGeneral.Return_Heading_Css(this.BoxTemplate);
    }

    protected void btn_search_Click1(object sender, EventArgs e)
    {
        if (this.SearchUrl != "" && txt_search.Text != "")
        {
            string separator = "?";
            if (this.SearchUrl.Contains("?"))
                separator = "&";
            Response.Redirect(this.SearchUrl + "" + separator + "query=" + Server.UrlEncode(UtilityBLL.CleanSearchTerm(txt_search.Text)));
        }
    }
}